//
//  TableController.m
//  Lister
//
//  Created by Linus Åkerlund on 4/1/09.
//  Copyright 2009 Linus Åkerlund. All rights reserved.
//

#import "TableController.h"

@implementation TableController
@synthesize nsMutaryDataObj; 
@synthesize idTableView;

//----------------------------------------------------------------------------
int sortFunc(id arg1, id arg2, void *context) {
	NSString *str1 = (NSString *)arg1;
	NSString *str2 = (NSString *)arg2;
	
	return [str1 compare:str2];
}

-(void) sizeToFit {
	printf("hello\n");
}

//----------------------------------------------------------------------------
- (void)updateView {
	[self.nsMutaryDataObj removeAllObjects];
	
	CFArrayRef windowList = CGWindowListCopyWindowInfo(kCGWindowListOptionOnScreenOnly | 
													   kCGWindowListExcludeDesktopElements, 
													   kCGNullWindowID);

	for (int i = 0; i < CFArrayGetCount(windowList); i++) {
		NSDictionary *val = (NSDictionary *)CFArrayGetValueAtIndex(windowList, i);
		NSString *appName = [val objectForKey:(id)kCGWindowOwnerName];
		if ([appName isEqualToString:@"Xcode"]) {
			NSString *windowName = [val objectForKey:(id)kCGWindowName];
			if (windowName && ![windowName isEqualToString:@""])
				[self.nsMutaryDataObj addObject:windowName];
		}
	}
	
	[nsMutaryDataObj sortUsingFunction:sortFunc context:NULL];
	[idTableView reloadData];
}

//----------------------------------------------------------------------------
- (void)awakeFromNib {
	[self checkUIElementsSupport];
	
	self.nsMutaryDataObj = [[NSMutableArray alloc]init];

	[self updateView];
	
	timer = [[NSTimer scheduledTimerWithTimeInterval:5 target:self 
											selector:@selector(updateView) 
											userInfo:nil repeats:YES] 
			 retain];
}

//----------------------------------------------------------------------------
- (int)numberOfRowsInTableView:(NSTableView *)pTableViewObj {
	return [self.nsMutaryDataObj count];
}

//----------------------------------------------------------------------------
- (id) tableView:(NSTableView *)pTableViewObj 
	objectValueForTableColumn:(NSTableColumn *)pTableColumn 
			 row:(int)pRowIndex {
	return [self.nsMutaryDataObj objectAtIndex:pRowIndex];
}

//----------------------------------------------------------------------------
- (void)tableView:(NSTableView *)pTableViewObj 
   setObjectValue:(id)pObject forTableColumn:(NSTableColumn *)pTableColumn 
			  row:(int)pRowIndex {
	return;
}

//----------------------------------------------------------------------------
void runAppleScript(NSString *script) {
	NSAppleScript *as = [[NSAppleScript alloc] initWithSource:script];
	[as compileAndReturnError:NULL];
	[as executeAndReturnError:NULL];
	[as release];	
}

//----------------------------------------------------------------------------
- (void)checkUIElementsSupport {
	NSString *script = [NSString stringWithCString:
		"tell application \"System Events\" \n"
			"get properties \n"
			"if not UI elements enabled then \n"
				"tell application \"System Preferences\" \n"
					"activate \n"
				"set current pane to pane \"com.apple.preference.universalaccess\" \n"
				"display dialog \"UI element scripting is not enabled. Check \\\"Enable access for assistive devices\\\"\" \n"
				"end tell \n"
			"end if \n"
		"end tell\n"
		encoding:NSASCIIStringEncoding];
	
	runAppleScript(script);
}

//----------------------------------------------------------------------------
- (BOOL)tableView:(NSTableView *)aTableView shouldSelectRow:(NSInteger)rowIndex {
	NSString *windowName = [self.nsMutaryDataObj objectAtIndex:rowIndex];
	NSString *script= [NSString stringWithFormat:@"tell application \"System Events\" "
					   "to tell process \"Xcode\" to perform action \"AXRaise\" of window \"%@\"\n", 
					   windowName];
	
	runAppleScript(script);
	
	return TRUE;
}

@end
